Bug 248716 - ftp/lftp: 4.9.2 fails to build with libressl
Summary: ftp/lftp: 4.9.2 fails to build with libressl
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Some People
Assignee: Ganael LAPLANCHE
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-08-18 06:49 UTC by Simeon Simeonov
Modified: 2020-08-21 05:45 UTC (History)
1 user (show)

See Also:


Attachments
Fix LibreSSL support (1.60 KB, patch)
2020-08-20 10:17 UTC, Ganael LAPLANCHE
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Simeon Simeonov 2020-08-18 06:49:35 UTC
Libressl fails to build against libressl-3.1.3 with the following error:

/bin/sh ../libtool --silent  --tag=CXX   --mode=compile c++ -DHAVE_CONFIG_H -I. -I../lib  -I../lib -I../trio  -I/usr/include  -DLIBICONV_PLUG -I/usr/local/include -isystem /usr/local/include -D_THREAD_SAFE  -O2 -pipe -fno-strict-aliasing -DLIBICONV_PLUG -fstack-protector-strong -isystem /usr/local/include  -DLIBICONV_PLUG -isystem /usr/local/include  -Wall -Wwrite-strings -Woverloaded-virtual -fno-exceptions -fno-rtti -fno-implement-inlines -MT liblftp_network_la-lftp_ssl.lo -MD -MP -MF .deps/liblftp_network_la-lftp_ssl.Tpo -c -o liblftp_network_la-lftp_ssl.lo `test -f 'lftp_ssl.cc' || echo './'`lftp_ssl.cc
lftp_ssl.cc:1164:10: error: use of undeclared identifier 'X509_STORE_CTX_get_by_subject'; did you mean 'X509_STORE_get_by_subject'?
    rc = X509_STORE_CTX_get_by_subject(store_ctx, X509_LU_CRL, subject, obj);
         ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         X509_STORE_get_by_subject
/usr/local/include/openssl/x509_vfy.h:479:5: note: 'X509_STORE_get_by_subject' declared here
int X509_STORE_get_by_subject(X509_STORE_CTX *vs,int type,X509_NAME *name,
    ^
lftp_ssl.cc:1204:10: error: use of undeclared identifier 'X509_STORE_CTX_get_by_subject'; did you mean 'X509_STORE_get_by_subject'?
    rc = X509_STORE_CTX_get_by_subject(store_ctx, X509_LU_CRL, issuer, obj);
         ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         X509_STORE_get_by_subject
/usr/local/include/openssl/x509_vfy.h:479:5: note: 'X509_STORE_get_by_subject' declared here
int X509_STORE_get_by_subject(X509_STORE_CTX *vs,int type,X509_NAME *name,
    ^
--- liblftp_network_la-Resolver.lo ---
mv -f .deps/liblftp_network_la-Resolver.Tpo .deps/liblftp_network_la-Resolver.Plo
--- liblftp_network_la-buffer_ssl.lo ---
/bin/sh ../libtool --silent  --tag=CXX   --mode=compile c++ -DHAVE_CONFIG_H -I. -I../lib  -I../lib -I../trio  -I/usr/include  -DLIBICONV_PLUG -I/usr/local/include -isystem /usr/local/include -D_THREAD_SAFE  -O2 -pipe -fno-strict-aliasing -DLIBICONV_PLUG -fstack-protector-strong -isystem /usr/local/include  -DLIBICONV_PLUG -isystem /usr/local/include  -Wall -Wwrite-strings -Woverloaded-virtual -fno-exceptions -fno-rtti -fno-implement-inlines -MT liblftp_network_la-buffer_ssl.lo -MD -MP -MF .deps/liblftp_network_la-buffer_ssl.Tpo -c -o liblftp_network_la-buffer_ssl.lo `test -f 'buffer_ssl.cc' || echo './'`buffer_ssl.cc
--- liblftp_network_la-lftp_ssl.lo ---
2 errors generated.
*** [liblftp_network_la-lftp_ssl.lo] Error code 1

make[4]: stopped in /usr/ports/ftp/lftp/work/lftp-4.9.2/src
--- liblftp_network_la-NetAccess.lo ---
mv -f .deps/liblftp_network_la-NetAccess.Tpo .deps/liblftp_network_la-NetAccess.Plo
--- SSH_Access.lo ---
mv -f .deps/SSH_Access.Tpo .deps/SSH_Access.Plo
--- liblftp_network_la-buffer_ssl.lo ---
mv -f .deps/liblftp_network_la-buffer_ssl.Tpo .deps/liblftp_network_la-buffer_ssl.Plo
1 error
Comment 1 Ganael LAPLANCHE freebsd_committer 2020-08-20 10:16:41 UTC
Hi Simeon,

Thanks for your report.

Compatibility with LibreSSL seems to have been broken upstream in commit 537f37898, see: https://github.com/lavv17/lftp/commit/537f37898

Can you test the attached patch please ?
Comment 2 Ganael LAPLANCHE freebsd_committer 2020-08-20 10:17:10 UTC
Created attachment 217368 [details]
Fix LibreSSL support
Comment 3 Simeon Simeonov 2020-08-20 12:03:07 UTC
Hi and thank you for the patch!

It fixed the build error for me.

Best regards

Simeon Simeonov
Comment 4 commit-hook freebsd_committer 2020-08-21 05:42:32 UTC
A commit references this bug:

Author: martymac
Date: Fri Aug 21 05:42:16 UTC 2020
New revision: 545573
URL: https://svnweb.freebsd.org/changeset/ports/545573

Log:
  Fix build with LibreSSL

  PR:		248716
  Submitted by:	Simeon Simeonov <sgs@pichove.org>

Changes:
  head/ftp/lftp/files/patch-src_lftp__ssl.cc
Comment 5 Ganael LAPLANCHE freebsd_committer 2020-08-21 05:45:42 UTC
Hello Simeon,

The patch has been committed.

Thanks for your feedback!

Best regards,
Ganael.